#!/usr/bin/python
'''
ICAP module, version 0.1
 
(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
'''

from avlib import *
import socket,re

__all__=['savse']

class icap:
  def __init__(self,host,port,path='AVTEST'):
      self.s=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
      socket_settimeout(self.s,120)
      self.s.connect((host,port))
      self.f=self.s.makefile('rw',0)
      self.server=host+":"+str(port)
      self.path=path
  def check(self,stream,filename):
      level=0.0
      # send ICAP request
      self.s.sendall("RESPMOD icap://"+self.server+"/"+self.path+" ICAP/1.0")
      self.s.sendall("\r\nHost: "+self.server+"\r\n")
      self.s.sendall("Allow: 204\r\n")
      req="GET http://sagator.salstar.sk/"+filename+" HTTP/1.1\r\n\r\n"
      hdr="HTTP/1.1 200 OK\r\nTransfer-Encoding: chunked\r\n\r\n"
      self.s.sendall("Encapsulated: req-hdr=0, res-hdr=%d, res-body=%d\r\n\r\n"
        % (len(req),len(req+hdr)))
      self.s.sendall(req)
      self.s.sendall(hdr)
      # send data stream
      self.s.sendall("%X\r\n" % len(stream))
      self.s.sendall(stream)
      self.s.sendall("\r\n\r\n0\r\n\r\n")
      # read protocol status
      ics=self.f.readline()
      try:
        icc=re.search("^ICAP/[0-9.]* ([0-9]{3}) ",ics).group(1)
      except:
        icc='000'
      if icc=='200':
        # returned OK
        for line in self.f.readlines():
          reg=re.search("^X-Infection-Found: Type=([0-9]*); Resolution=([0-9]*); Threat=([^;]*);",line)
          if reg:
            if (reg.group(1)=='0') and (reg.group(2)=='0'):
              print reg.group(3)
              level+=1.0
      else:
        if icc!='204':
          raise 'e',ics
      return level,''
  def close(self):
      self.s.shutdown(2)

class savse(ascanner):
  '''
  savse() realscanner - symantec antivirus scan engine scanner
  
  Usage: savse(('host',port))
  
  Example: savse(('localhost',7777))
  '''
  name='savse()'
  def __init__(self,arg):
      self.arg=arg
  def scanstream(self,stream):
      c=icap(self.arg[0],self.arg[1])
      level,r=c.check(stream,self.filename)
      c.close()
      if r:
        return level,r,[self.filename+": "+r]
