'''
kav module - Kaspersky support, version 0.1

(c) 2003-2004 Laszlo BALINT (blaci) <balint_laszlo@tiszanet.hu>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from avlib import *
import os,re,string

__all__=['kav']

class kav(ascanner):
  '''
  Kaspersky realscanner
  
  Usage: kav(command)

  Where: command is a array which defines command with parameters.
           By default: ['/opt/kav/bin/kavscanner','-j3']

  This scanners is a realscanner, which can be used to scan
  for viruses. It parses Kaspersky antivirus output.
  '''
  name='kav()'
  def __init__(self,command=['/opt/kav/bin/kavscanner','-j3']):
      self.command=command
  def scanfile(self,files,dir=''):
      level,detected,virlist,vir_count,ret=0.0,'',[],0,[]
      if dir:
        pf=popen(self.command+[safe.fn(dir)])
      else:
        safe_files=[]
        for i in files:
          safe_files.append(safe.fn(i))
        print safe_files
        pf=popen(self.command+safe_files)
      pf.tocmd.close()
      rc=pf.wait()
      # read lines from command
      while 1:
        line=pf.readline()
        if line=='': break
        if re.search("^Config file:",line):
          while 1:
            line=pf.readline()
            if line=='': break
            if re.search("INFECTED",line):
              vir_count=vir_count+1
              re1=re.search("(INF|SUSP)ECTED (.*)",line.rstrip())
              debug.echo(3,"INFECTED: kav(): ",re1)
              if re1:
                if re1.group(1)=="INF": # if it is an indentified virus
                  detected=re1.group(2)
                  level+=1.0
                else:
                  level+=0.9
                  if detected=='': # if it is suspected, but no ident. virus
                    detected=re1.group(2)
                ret.append(line)
          break
      pf.fromcmd.close()
      debug.echo(4,"KAV: RET: ",[[vir_count,rc]],ret)
      return level,detected,virlist
